package me.icymint.libra.sage.core.dialect;

public enum Dialect {
	MySql(new MySqlDialect("MySQL")), SqlServer(new SqlServerDialect(
			"Microsoft SQL Server")), Db2Nt(new DB2NTDialect("DB2/NT"));
	public static Dialect getDialect(String databaseProductName)
			throws DataSourceNotSupportException {
		for (Dialect d : Dialect.values()) {
			if (d.getDatabaseProductname().equals(databaseProductName)) {
				return d;
			}
		}
		throw new DataSourceNotSupportException(databaseProductName + " 暂不支持！");
	}

	private final SqlDialect sd;

	Dialect(SqlDialect sd) {
		this.sd = sd;
	}

	public String getDatabaseProductname() {
		return sd.getDatabaseProductName();
	}

	public SqlDialect getSqlDialect() {
		return sd;
	}
}
