package me.icymint.libra.sage.core.dialect.query;

import java.sql.SQLException;
import java.util.List;

import me.icymint.libra.sage.model.SqlTable;
import me.icymint.libra.sage.model.SqlVar;

public interface AdvancedQuery<T> {
	int JOIN = 0;
	int LEFT_JOIN = 1;
	int RIGHT_JOIN = 2;
	int INNER_JOIN = 3;
	int CROSS_JOIN = 4;

	List<T> commit() throws SQLException;

	List<T> commit(int limit) throws SQLException;

	List<T> commit(int offset, int limit) throws SQLException;

	AdvancedQuery<T> groupBy(SqlVar... vs);

	String join(int type);

	AdvancedQuery<T> join(int type, SqlTable t);

	AdvancedQuery<T> orderBy(SqlVar... vs);

	AdvancedQuery<T> select(QueryVar... qv);

	AdvancedQuery<T> where(QueryCondition qc);
}
