package me.icymint.libra.sage.core.dialect.query;

import me.icymint.libra.sage.model.SqlTable;
import me.icymint.libra.sage.model.SqlVar;

public class BasicQueryVar extends QueryVar {

	private SqlTable t;
	private SqlVar v;
	private SqlInnerFunction sif;

	public BasicQueryVar(SqlTable t, SqlVar v, SqlInnerFunction sif) {
		this.t = t;
		this.v = v;
		if (sif == null)
			sif = SqlInnerFunction.NULL;
		this.sif = sif;
	}

	@Override
	public SqlTable getTable() {
		return t;
	}

	@Override
	public String getText() {
		StringBuilder sb = new StringBuilder(t.toString()).append(".").append(
				v.toString());
		if (sif.equals(SqlInnerFunction.NULL)) {
			return sb.toString();
		} else {
			return new StringBuilder(sif.name()).append("(")
					.append(sb.toString()).append(")").toString();
		}
	}

	@Override
	public SqlVar getVar() {
		return v;
	}
}
