package me.icymint.libra.sage.core.dialect.query;

public class InQueryCondition extends QueryCondition {

	private final QueryVar qv;
	private final ConstQueryVar[] v;

	public InQueryCondition(QueryVar qv, ConstQueryVar... v) {
		super(false);
		this.qv = qv;
		this.v = v;
	}

	@Override
	public String getText() {
		if (v.length == 0)
			return "";
		else {
			StringBuilder sb = new StringBuilder(qv.getText()).append(" IN (")
					.append(v[0].getText());
			for (int i = 1; i < v.length; i++) {
				sb.append(",").append(v[i].getText());
			}
			return sb.append(")").toString();
		}
	}

}
