package me.icymint.libra.sage.core.query;

import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.ResultSet;
import java.sql.SQLException;

import me.icymint.libra.sage.core.result.MetaDataResultHandler;

/**
 * 所有非SQL语句执行的基类。 此种执行一般是从{@link DatabaseMetaData}中获取一些元数据信息。 例如获取所有CaltaLog名称。
 * 
 * @author Daniel
 * @datetime 2012-11-9下午1:54:07
 * 
 * @param <T>
 */
public class MetaDataQuery<T> implements SqlQuery<T> {

	private MetaDataResultHandler<T> rh;

	public MetaDataQuery(MetaDataResultHandler<T> rh) {
		if (rh == null) {
			throw new NullPointerException("ResultHandler不可为空！");
		}
		this.rh = rh;
	}

	@Override
	public T query(Connection conn) throws SQLException {
		ResultSet rs = rh.queryResultSet(conn.getMetaData());
		try {
			T t = rh.handle(rs);
			return t;
		} catch (SQLException e) {
			throw e;
		} finally {
			rs.close();
		}
	}

}
