package me.icymint.libra.sage.core.result;

import java.sql.ResultSet;
import java.sql.SQLException;

/**
 * 把结果转换成标量，例如获取单个String。
 * 
 * @author Daniel
 * @datetime 2012-11-12上午10:59:24
 * 
 * @param <E>
 */
public class ScalarResult<E> extends AbstractResultHandler<E> {
	private final ScalarListResult<E> slr;

	public ScalarResult() {
		this(1);
	}

	public ScalarResult(int i) {
		super(1);
		slr = new ScalarListResult<E>(i, 1);
	}

	@Override
	public E handle(ResultSet rs) throws SQLException {
		if (rs.next()) {
			return slr.handle(rs, 1);
		}
		throw new SQLException("查询标量结果不正确!");
	}

}
