package me.icymint.libra.sage.model.operator;

import java.sql.SQLException;
import java.util.Collection;
import java.util.List;

import me.icymint.libra.sage.model.orm.DataPack;

/**
 * SQL增删查改基础接口。
 * 
 * @author Daniel
 * @datetime 2012-12-11下午5:10:00
 * 
 * @param <T>
 */
public interface Curd {
	<T> void delete(T t) throws SQLException;

	<T> void deleteByKey(T t) throws SQLException;

	<T> void insert(T t) throws SQLException;

	<T> void insertAll(Collection<T> coll) throws SQLException;

	List<DataPack> query() throws SQLException;

	<T> List<T> query(Class<T> cls) throws SQLException;

	<T> List<T> query(Class<T> cls, int offset, int limit) throws SQLException;

	List<DataPack> query(int offset, int limit) throws SQLException;

	<T> T queryByKey(Class<T> cls, Object... key) throws SQLException;

	DataPack queryByKey(Object... key) throws SQLException;

	<T> List<T> queryByName(Class<T> cls, String[] vars, Object... values)
			throws SQLException;

	List<DataPack> queryByName(String[] vars, Object... values)
			throws SQLException;

	/**
	 * 同步数据库中数据到T对象。 注意，此同步仅仅获取自增型的主键值。
	 * 
	 * @param t
	 * @throws SQLException
	 */
	<T> T sync(T t) throws SQLException;

	<T> void update(T t) throws SQLException;

	<T> void updateAll(Collection<T> t) throws SQLException;
}
