package me.icymint.libra.sage.model.orm;

import java.util.LinkedHashMap;
import java.util.Map;

import me.icymint.libra.sage.model.SqlVar;

public class DataPack {

	private final Object[] value;
	private final Map<String, Object> p = new LinkedHashMap<String, Object>();
	private final SqlVar[] sv;
	private final static String formatt = "%1$03d+%1$032d+%1$032d+%1$032d";
	private final static String format = "%1$03d|%2$-32s|%3$-32s|";

	public DataPack(SqlVar[] sv, Object[] value) {
		this.sv = sv;
		this.value = value;
		for (int i = 0; i < sv.length; i++) {
			Object o = value[i];
			if (o != null)
				p.put(sv[i].getName(), o);
		}
	}

	public Object getValue(int ind) {
		return value[ind];
	}

	public Object getValue(SqlVar v) {
		return getValue(v.getName());
	}

	public Object getValue(String var) {
		return p.get(var);
	}

	public Object[] getValues() {
		return value;
	}

	public void print() {
		System.out.println(String.format(formatt, 0).replaceAll("0", "-"));
		for (int i = 0; i < sv.length; i++) {
			Object o = this.getValue(i);
			String x = String.format(format, i, sv[i].getDescription(),
					o != null ? o.getClass().getSimpleName() : null);
			System.out.println(x + o);
		}
	}
}
